-module(ex3).

-export([ empty_tree/0
        , insert/2]).

-record(tree, {info, left=empty, right=empty}).

empty_tree()               -> empty.
tree_info(#tree{info = I}) -> I.
tree_left(#tree{left = L}) -> L.
tree_right(#tree{left = R}) -> R.

is_empty_tree(empty)   -> true;
is_empty_tree(#tree{}) -> false.

mk_node(E)              -> #tree{info = E}.
mk_tree(E, Left, Right) -> #tree{info = E, left = Left, right = Right}.

insert(E, Tree) ->
  case is_empty_tree(Tree) of
    true  -> mk_node(E);
    false ->
      I = tree_info(Tree),
      if E == I -> Tree;
         E < I ->
          mk_tree(I, insert(E, tree_left(Tree)), tree_right(Tree));
         true ->
          mk_tree(I, tree_left(Tree), insert(E, tree_right(Tree)))
      end
  end.

