-module(ex5).

-export([ fib/1
        , fibfun/0
        ]).

fib(0) -> 1;
fib(1) -> 1;
fib(N) -> fib(N-1) + fib(N-2).

fibfun() ->
  Cache = dict:new(),
  Pid = spawn(fun() -> loop(Cache) end),
  fun(N) ->
      Pid ! {self(), N},
      receive
        V -> V
      end
  end.

loop(Cache) ->
  receive
    {Pid, N} ->
      case dict:find(N, Cache) of
        {ok, Value} ->
          NewCache = Cache;
        error ->
          Value = fib(N),
          NewCache = dict:store(N, Value, Cache)
      end,
      Pid ! Value,
      loop(NewCache)
  end.
